/********************************************************/
/*  H83067F.H   All internal registers defines          */
/*                                                      */
/*  Taken from Hitachi samples (H8/3048 CMON)           */
/*                                                      */
/*  Revised 25/11/99 for H8/3067                        */
/********************************************************/
/* DMA channels */
#define DMAC_MAR0AR   (* (volatile BYTE *)      ( 0xffff20 ))
#define DMAC_MAR0AE   (* (volatile BYTE *)      ( 0xffff21 ))
#define DMAC_MAR0AH   (* (volatile BYTE *)      ( 0xffff22 ))
#define DMAC_MAR0AL   (* (volatile BYTE *)      ( 0xffff23 ))
#define DMAC_ETCR0AH  (* (volatile BYTE *)      ( 0xffff24 ))
#define DMAC_ETCR0AL  (* (volatile BYTE *)      ( 0xffff25 ))
#define DMAC_ETCR0A   (* (volatile unsigned short *)  ( 0xffff24 ))
#define DMAC_IOAR0A   (* (volatile BYTE *)      ( 0xffff26 ))
#define DMAC_DTCR0A   (* (volatile BYTE *)      ( 0xffff27 ))
#define DMAC_MAR0AW   (* (volatile unsigned short *)  ( 0xffff22 ))
#define DMAC_MAR0A    (* (volatile unsigned long *)   ( 0xffff20 ))

#define DMAC_MAR0BR   (* (volatile BYTE *)      ( 0xffff28 ))
#define DMAC_MAR0BE   (* (volatile BYTE *)      ( 0xffff29 ))
#define DMAC_MAR0BH   (* (volatile BYTE *)      ( 0xffff2a ))
#define DMAC_MAR0BL   (* (volatile BYTE *)      ( 0xffff2b ))
#define DMAC_ETCR0BH  (* (volatile BYTE *)      ( 0xffff2c ))
#define DMAC_ETCR0BL  (* (volatile BYTE *)      ( 0xffff2d ))
#define DMAC_ETCR0B   (* (volatile unsigned short *)  ( 0xffff2c ))
#define DMAC_IOAR0B   (* (volatile BYTE *)      ( 0xffff2e ))
#define DMAC_DTCR0B   (* (volatile BYTE *)      ( 0xffff2f ))
#define DMAC_MAR0BW   (* (volatile unsigned short *)  ( 0xffff2a ))
#define DMAC_MAR0B    (* (volatile unsigned long *)   ( 0xffff28 ))

#define DMAC_MAR1AR   (* (volatile BYTE *)      ( 0xffff30 ))
#define DMAC_MAR1AE   (* (volatile BYTE *)      ( 0xffff31 ))
#define DMAC_MAR1AH   (* (volatile BYTE *)      ( 0xffff32 ))
#define DMAC_MAR1AL   (* (volatile BYTE *)      ( 0xffff33 ))
#define DMAC_ETCR1AH  (* (volatile BYTE *)      ( 0xffff34 ))
#define DMAC_ETCR1AL  (* (volatile BYTE *)      ( 0xffff35 ))
#define DMAC_ETCR1A   (* (volatile unsigned short *)  ( 0xffff34 ))
#define DMAC_IOAR1A   (* (volatile BYTE *)      ( 0xffff36 ))
#define DMAC_DTCR1A   (* (volatile BYTE *)      ( 0xffff37 ))
#define DMAC_MAR1AW   (* (volatile unsigned short *)  ( 0xffff32 ))
#define DMAC_MAR1A    (* (volatile unsigned long *)   ( 0xffff30 ))

#define DMAC_MAR1BR   (* (volatile BYTE *)      ( 0xffff38 ))
#define DMAC_MAR1BE   (* (volatile BYTE *)      ( 0xffff39 ))
#define DMAC_MAR1BH   (* (volatile BYTE *)      ( 0xffff3a ))
#define DMAC_MAR1BL   (* (volatile BYTE *)      ( 0xffff3b ))
#define DMAC_ETCR1BH  (* (volatile BYTE *)      ( 0xffff3c ))
#define DMAC_ETCR1BL  (* (volatile BYTE *)      ( 0xffff3d ))
#define DMAC_ETCR1B   (* (volatile unsigned short *)  ( 0xffff3c ))
#define DMAC_IOAR1B   (* (volatile BYTE *)      ( 0xffff3e ))
#define DMAC_DTCR1B   (* (volatile BYTE *)      ( 0xffff3f ))
#define DMAC_MAR1BW   (* (volatile unsigned short *)  ( 0xffff3a ))
#define DMAC_MAR1B    (* (volatile unsigned long *)   ( 0xffff38 ))

/* ITU - 16 bit all channels*/
#define ITU_TSTR      (* (volatile BYTE *)      ( 0xffff60 ))
#define ITU_TSNC      (* (volatile BYTE *)      ( 0xffff61 ))
#define ITU_TMDR      (* (volatile BYTE *)      ( 0xffff62 ))
#define ITU_TOLR      (* (volatile BYTE *)      ( 0xffff63 ))
#define ITU_TISRA     (* (volatile BYTE *)      ( 0xffff64 ))
#define ITU_TISRB     (* (volatile BYTE *)      ( 0xffff65 ))
#define ITU_TISRC     (* (volatile BYTE *)      ( 0xffff66 ))

/* ITU - 16 bit channel 0 */
#define ITU_TCR0      (* (volatile BYTE *)      ( 0xffff68 ))
#define ITU_TIOR0     (* (volatile BYTE *)      ( 0xffff69 ))
#define ITU_TCNT0     (* (volatile unsigned short *)  ( 0xffff6a ))
#define ITU_GRA0      (* (volatile unsigned short *)  ( 0xffff6c ))
#define ITU_GRB0      (* (volatile unsigned short *)  ( 0xffff6e ))

/* ITU - 16 bit channel 1 */
#define ITU_TCR1      (* (volatile BYTE *)      ( 0xffff70 ))
#define ITU_TIOR1     (* (volatile BYTE *)      ( 0xffff71 ))
#define ITU_TCNT1     (* (volatile unsigned short *)  ( 0xffff72 ))
#define ITU_GRA1      (* (volatile unsigned short *)  ( 0xffff74 ))
#define ITU_GRB1      (* (volatile unsigned short *)  ( 0xffff76 ))

/* ITU - 16 bit channel 2 */
#define ITU_TCR2      (* (volatile BYTE *)      ( 0xffff78 ))
#define ITU_TIOR2     (* (volatile BYTE *)      ( 0xffff79 ))
#define ITU_TCNT2     (* (volatile unsigned short *)  ( 0xffff7a ))
#define ITU_GRA2      (* (volatile unsigned short *)  ( 0xffff7c ))
#define ITU_GRB2      (* (volatile unsigned short *)  ( 0xffff7e ))

/* ITU - 8 bit chanels 0 and 1 */
#define ITU8_TCR0      (* (volatile BYTE *)     ( 0xffff80 ))
#define ITU8_TCR1      (* (volatile BYTE *)     ( 0xffff81 ))
#define ITU8_TCSR0     (* (volatile BYTE *)     ( 0xffff82 ))
#define ITU8_TCSR1     (* (volatile BYTE *)     ( 0xffff83 ))
#define ITU8_TCORA0    (* (volatile BYTE *)     ( 0xffff84 ))
#define ITU8_TCORA1    (* (volatile BYTE *)     ( 0xffff85 ))
#define ITU8_TCORB0    (* (volatile BYTE *)     ( 0xffff86 ))
#define ITU8_TCORB1    (* (volatile BYTE *)     ( 0xffff87 ))
#define ITU8_TCNT0     (* (volatile BYTE *)     ( 0xffff88 ))
#define ITU8_TCNT1     (* (volatile BYTE *)     ( 0xffff89 ))

/* ITU - 8 bit chanels 2 and 3 */
#define ITU8_TCR2      (* (volatile BYTE *)     ( 0xffff90 ))
#define ITU8_TCR3      (* (volatile BYTE *)     ( 0xffff91 ))
#define ITU8_TCSR2     (* (volatile BYTE *)     ( 0xffff92 ))
#define ITU8_TCSR3     (* (volatile BYTE *)     ( 0xffff93 ))
#define ITU8_TCORA2    (* (volatile BYTE *)     ( 0xffff94 ))
#define ITU8_TCORA3    (* (volatile BYTE *)     ( 0xffff95 ))
#define ITU8_TCORB2    (* (volatile BYTE *)     ( 0xffff96 ))
#define ITU8_TCORB3    (* (volatile BYTE *)     ( 0xffff97 ))
#define ITU8_TCNT2     (* (volatile BYTE *)     ( 0xffff98 ))
#define ITU8_TCNT3     (* (volatile BYTE *)     ( 0xffff99 ))

/* TPC */
#define TPC_TPMR      (* (volatile BYTE *)      ( 0xffffa0 ))
#define TPC_TPCR      (* (volatile BYTE *)      ( 0xffffa1 ))
#define TPC_NDERB     (* (volatile BYTE *)      ( 0xffffa2 ))
#define TPC_NDERA     (* (volatile BYTE *)      ( 0xffffa3 ))
#define TPC_NDRB1     (* (volatile BYTE *)      ( 0xffffa4 ))
#define TPC_NDRA1     (* (volatile BYTE *)      ( 0xffffa5 ))
#define TPC_NDRB2     (* (volatile BYTE *)      ( 0xffffa6 ))
#define TPC_NDRA2     (* (volatile BYTE *)      ( 0xffffa7 ))

/* WDT */
#define WDT_TCSR      (* (volatile BYTE *)      ( 0xffff8c ))
#define WDT_TCNT      (* (volatile BYTE *)      ( 0xffff8d ))
#define WDT_RSTCSR    (* (volatile BYTE *)      ( 0xffff8f ))

/*  REFRESH CTRLR + DRAM I/F */
#define DCRA          (* (volatile BYTE *)      ( 0xfee026 ))
#define DCRB          (* (volatile BYTE *)      ( 0xfee027 ))
#define RTMCSR        (* (volatile BYTE *)      ( 0xfee028 ))
#define RTCNT         (* (volatile BYTE *)      ( 0xfee029 ))
#define RTCOR         (* (volatile BYTE *)      ( 0xfee02a ))

/* Serial Comms, channels 0 to 2 */
#define SCI0_SMR      (* (volatile BYTE *)      ( 0xffffb0 ))
#define SCI0_BRR      (* (volatile BYTE *)      ( 0xffffb1 ))
#define SCI0_SCR      (* (volatile BYTE *)      ( 0xffffb2 ))
#define SCI0_TDR      (* (volatile BYTE *)      ( 0xffffb3 ))
#define SCI0_SSR      (* (volatile BYTE *)      ( 0xffffb4 ))
#define SCI0_RDR      (* (volatile BYTE *)      ( 0xffffb5 ))
#define SCI0_SCMR     (* (volatile BYTE *)      ( 0xffffb6 ))

#define SCI1_SMR      (* (volatile BYTE *)      ( 0xffffb8 ))
#define SCI1_BRR      (* (volatile BYTE *)      ( 0xffffb9 ))
#define SCI1_SCR      (* (volatile BYTE *)      ( 0xffffba ))
#define SCI1_TDR      (* (volatile BYTE *)      ( 0xffffbb ))
#define SCI1_SSR      (* (volatile BYTE *)      ( 0xffffbc ))
#define SCI1_RDR      (* (volatile BYTE *)      ( 0xffffbd ))
#define SCI1_SCMR     (* (volatile BYTE *)      ( 0xffffbe ))

#define SCI2_SMR      (* (volatile BYTE *)      ( 0xffffc0 ))
#define SCI2_BRR      (* (volatile BYTE *)      ( 0xffffc1 ))
#define SCI2_SCR      (* (volatile BYTE *)      ( 0xffffc2 ))
#define SCI2_TDR      (* (volatile BYTE *)      ( 0xffffc3 ))
#define SCI2_SSR      (* (volatile BYTE *)      ( 0xffffc4 ))
#define SCI2_RDR      (* (volatile BYTE *)      ( 0xffffc5 ))
#define SCI2_SCMR     (* (volatile BYTE *)      ( 0xffffc6 ))

/* IO ports */
#define P1DR          (* (volatile BYTE *)      ( 0xffffd0 ))
#define P1DDR         (* (volatile BYTE *)      ( 0xfee000 ))

#define P2CR          (* (volatile BYTE *)      ( 0xfee03c ))
#define P2DR          (* (volatile BYTE *)      ( 0xffffd1 ))
#define P2DDR         (* (volatile BYTE *)      ( 0xfee001 ))

#define P3DR          (* (volatile BYTE *)      ( 0xffffd2 ))
#define P3DDR         (* (volatile BYTE *)      ( 0xfee002 ))

#define P4CR          (* (volatile BYTE *)      ( 0xfee03e ))
#define P4DR          (* (volatile BYTE *)      ( 0xffffd3 ))
#define P4DDR         (* (volatile BYTE *)      ( 0xfee003 ))

#define P5CR          (* (volatile BYTE *)      ( 0xfee03f ))
#define P5DR          (* (volatile BYTE *)      ( 0xffffd4 ))
#define P5DDR         (* (volatile BYTE *)      ( 0xfee004 ))

#define P6DR          (* (volatile BYTE *)      ( 0xffffd5 ))
#define P6DDR         (* (volatile BYTE *)      ( 0xfee005 ))

#define P7DR          (* (volatile BYTE *)      ( 0xffffd6 ))

#define P8DR          (* (volatile BYTE *)      ( 0xffffd7 ))
#define P8DDR         (* (volatile BYTE *)      ( 0xfee007 ))

#define P9DR          (* (volatile BYTE *)      ( 0xffffd8 ))
#define P9DDR         (* (volatile BYTE *)      ( 0xfee008 ))

#define PADR          (* (volatile BYTE *)      ( 0xffffd9 ))
#define PADDR         (* (volatile BYTE *)      ( 0xfee009 ))

#define PBDR          (* (volatile BYTE *)      ( 0xffffda ))
#define PBDDR         (* (volatile BYTE *)      ( 0xfee00a ))

/* D/A CONVERTER */
#define DADR0         (* (volatile BYTE *)      ( 0xffff9c ))
#define DADR1         (* (volatile BYTE *)      ( 0xffff9d ))
#define DACR          (* (volatile BYTE *)      ( 0xffff9e ))

/* A/D Converter */
#define ADDRA         (* (volatile unsigned short *)  ( 0xffffe0 ))
#define ADDRAH        (* (volatile BYTE *)      ( 0xffffe0 ))
#define ADDRAL        (* (volatile BYTE *)      ( 0xffffe1 ))
#define ADDRB         (* (volatile unsigned short *)  ( 0xffffe2 ))
#define ADDRBH        (* (volatile BYTE *)      ( 0xffffe2 ))
#define ADDRBL        (* (volatile BYTE *)      ( 0xffffe3 ))
#define ADDRC         (* (volatile unsigned short *)  ( 0xffffe4 ))
#define ADDRCH        (* (volatile BYTE *)      ( 0xffffe4 ))
#define ADDRCL        (* (volatile BYTE *)      ( 0xffffe5 ))
#define ADDRD         (* (volatile unsigned short *)  ( 0xffffe6 ))
#define ADDRDH        (* (volatile BYTE *)      ( 0xffffe6 ))
#define ADDRDL        (* (volatile BYTE *)      ( 0xffffe7 ))
#define ADCSR         (* (volatile BYTE *)      ( 0xffffe8 ))
#define ADCR          (* (volatile BYTE *)      ( 0xffffe9 ))

/* BUS CTRLR */
#define ABWCR         (* (volatile BYTE *)      ( 0xfee020 ))
#define ASTCR         (* (volatile BYTE *)      ( 0xfee021 ))
#define WCRH          (* (volatile BYTE *)      ( 0xfee022 ))
#define WCRL          (* (volatile BYTE *)      ( 0xfee023 ))
#define BCR           (* (volatile BYTE *)      ( 0xfee024 ))

/* SYSTEM CTRL */
#define MDCR          (* (volatile BYTE *)      ( 0xfee011 ))
#define SYSCR         (* (volatile BYTE *)      ( 0xfee012 ))
#define BRCR          (* (volatile BYTE *)      ( 0xfee013 ))
#define DASTCR        (* (volatile BYTE *)      ( 0xfee01a ))
#define DIVCR         (* (volatile BYTE *)      ( 0xfee01b ))
#define MSTCRH        (* (volatile BYTE *)      ( 0xfee01c ))
#define MSTCRL        (* (volatile BYTE *)      ( 0xfee01d ))
#define ADRCR         (* (volatile BYTE *)      ( 0xfee01e ))
#define CSCR          (* (volatile BYTE *)      ( 0xfee01f ))

/* INTERRUPT CTRLR */
#define ISCR          (* (volatile BYTE *)      ( 0xfee014 ))
#define IER           (* (volatile BYTE *)      ( 0xfee015 ))
#define ISR           (* (volatile BYTE *)      ( 0xfee016 ))
#define IPRA          (* (volatile BYTE *)      ( 0xfee018 ))
#define IPRB          (* (volatile BYTE *)      ( 0xfee019 ))

/* FLASH CONTROL */
#define FLMCR         (* (volatile BYTE *)      ( 0xfee030 ))
#define EBR           (* (volatile BYTE *)      ( 0xfee032 ))
#define RAMCR         (* (volatile BYTE *)      ( 0xfee077 ))
#define FLMSR         (* (volatile BYTE *)      ( 0xfee07D ))

