/*--------------------------------------------------------------*/
/* ASCII.H                                                      */
/* ascii character definitions for H8 min mode monitor          */
/*--------------------------------------------------------------*/
/* Aug 01, 1991 */
/*--------------*/

/*-----------------------------------------------------------------------*/
/* Ascii Chart                                                           */
/*       0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F   */
/*  0:   NUL SOH STX ETX EOT ENQ ACK BEL BS  HT  LF  VT  FF  CR  SO  SI  */
/*  1:   DLE DC1 DC2 DC3 DC4 NAK SYN ETB CAN EM  SUB ESC FS  GS  RS  US  */
/*  2:       !   "   #   $   %   &   '   (   )   *   +   ,   -   .   /   */
/*  3:   0   1   2   3   4   5   6   7   8   9   :   ;   <   =   >   ?   */
/*  4:   @   A   B   C   D   E   F   G   H   I   J   K   L   M   N   O   */
/*  5:   P   Q   R   S   T   U   V   W   X   Y   Z   [   \   ]   ^   _   */
/*  6:   `   a   b   c   d   e   f   g   h   i   j   k   l   m   n   o   */
/*  7:   p   q   r   s   t   u   v   w   x   y   z   {   |   }   ~   DEL */
/*-----------------------------------------------------------------------*/
#define NUL     0x00            /* Null */
#define SOH     0x01            /* Start of Heading */
#define STX     0x02            /* Start of Text */
#define ETX     0x03            /* End of Text */
#define EOT     0x04            /* End of Transmission */
#define ENQ     0x05            /* Enquiry */
#define ACK     0x06            /* Positive Acknowledgement */
#define BEL     0x07            /* Bell */
#define BS      0x08            /* Back Space */
#define HT      0x09            /* Horizontal Tab */
#define LF      0x0A            /* Line Feed */
#define VT      0x0B            /* Vertical Tab */
#define FF      0x0C            /* Form Feed */
#define CR      0x0D            /* Carriage Return */
#define SO      0x0E            /* Shift Out */
#define SI      0x0F            /* Shift In */
#define DLE     0x10            /* Data Link Escape */
#define DC1     0x11            /* Device Control 1 */
#define DC2     0x12            /* Device Control 2 */
#define DC3     0x13            /* Device Control 3 */
#define DC4     0x14            /* Device Control 4 */
#define NAK     0x15            /* Negative Acknowledgement */
#define SYN     0x16            /* Synchronous Idle */
#define ETB     0x17 
#define CAN     0x18            /* Cancel */
#define EM      0x19            /* End of Medium */
#define SUB     0x1A
#define ESC     0x1B            /* Escape */
#define FS      0x1C            /* File Separator */
#define GS      0x1D            /* Group Separator */
#define RS      0x1E            /* Record Separator */
#define US      0x1F            /* Unit Separator */
#define SPACE   0x20            /* Space */
#define DEL     0x7F            /* Delete */
#define XON     DC1             /* xon (control Q) */
#define XOFF    DC3             /* xoff (control S) */

