/**************************************************************
H8CORE_B.H

    H8 core function fo controlling Digital LCD controller. 79049

    Date    13/12/99

    Author  Paul Carpenter
***************************************************************/
#define H8300H 1
#define COOKIE 0x5ac5ac
#define CPU __H8300H__

/***** Fixed Data...(ish) ******************************/
extern unsigned long check_sum;

/**************** Global Variables  ********************/
extern BYTE status;
extern BYTE sys_status;
extern BYTE mode;
extern BYTE time_count;
extern const char *company;
extern const char *date;
extern const char *product;
extern const char *rev;

extern BYTE event_ticks[ MAX_EVENTS ][ 2 ];
extern int  i, j;

/**** CUSTOM crt0 address definitions of special memory locations **/
/* these should be in a file called crt0.h */
extern BYTE temp_array[ 256 ];
extern BYTE temp_array1[ 256 ];

/* SIO 0 buffers */
extern BYTE rx_buf0[ 32 ];
extern BYTE tx_buf0[ 16 ];
/* SIO 1 buffers */
extern BYTE rx_buf1[ 32 ];
extern BYTE tx_buf1[ 16 ];
/* SIO 2 buffers */
extern BYTE rx_buf2[ 32 ];
extern BYTE tx_buf2[ 16 ];

/****************** Prototypes ************************/
extern int  send_status( void );
extern int  send_version( void );
extern void timer_tick( void );

/* crt0 special functions */
extern void disable_int( void );           /* Disable H8 Interupts */
extern void enable_int( void );            /* Enable H8 Interupts */

