; A FAIRE : lire A2D et send sur RS232
; 2min15sec pour un sweep de 6 a 4 MHz avec increments de 0xFF

; DDS connections: DATA=P4-0=1-31;     CK=P4-1=1-32;     FQ_UD=P4-2=1-33
	.h8300h
; .section .start
	.align 1
	.global _start

_start:
       mov.l   #0xffefc,er7		; =mov.l ...,sp : sett stack pointer
       ldc.b   #0xc0,  ccr             ; disable interrupt
       mov.b   #0x00,  r0l             ; 2-State Access(All area)
       mov.b   r0l,@0xffffed

       mov.b   #0xff,r0l  		; set P4 as output
       mov.b   r0l,@0xfffc5 		; |
       mov.b   r0l,@0xfffc8 		; set P5 as output
       mov.b   #0x00,r0l  		; set P4 low
       mov.b   r0l,@0xfffc7 		; |

       bset    #0x0,@0xfffe8:8 ; select A/D 1 (fffe8=AD1 ctrl) 

        bset    #4,@0xfffba:8   ; SCI initialization
        bset    #5,@0xfffba:8   ; |     
        mov.w   #0xff00,r0      ; |
	mov.b   r0h,@0xfffd4:24 ; |

init_dds:
	bset	#1,@0xfffc7:8		; CK=bit 1 of PORT 4
	bclr	#1,@0xfffc7:8		; CK=bit 1 of PORT 4
	bsr	DELAI
	bset	#2,@0xfffc7:8		; FQ_UD=bit 1 of PORT 4
	bclr	#2,@0xfffc7:8		; FQ_UD=bit 1 of PORT 4
	bsr	DELAI

debut:
	bset	#0,@0xfffca:8	; P5DR et C8 -> FF pour out:
	bclr	#1,@0xfffca:8	; P5DR et C8 -> FF pour out:
	bsr	DELAI
	bclr	#0,@0xfffca:8	; P5DR et C8 -> FF pour out:
	bset	#1,@0xfffca:8	; P5DR et C8 -> FF pour out:

	mov.l	#0x33000000,er3		; SET TO START VALUE to 6 MHz (5.976)
	; mov.l	#0xfaf5f6f0,er3		; er3=freq  TEST PATTERN
	; mov.l	#0x02000000,er3		; er3=freq  -> 234 kHz
	; mov.l	#0x01aaaaaa,er3		; er3=freq  -> 227 kHz
	; mov.l	#0x01000000,er3		; er3=freq  -> 117 kHz
	; mov.l	#0x11000000,er3		; er3=freq  -> 1.98 MHz

	mov	#0x01,r1l
	jsr	snd
	mov	#0xff,r1l
	jsr	snd
	mov	#0x02,r1l
	jsr	snd
	mov	#0xfe,r1l
	jsr	snd
	mov	#0x80,r1l
	jsr	snd
boucle:
	; sub.l	#0x00000100,er3		; freq dec par 30E6/2^32*256=1.8 Hz
	sub.l	#0x00001000,er3		; freq dec par 30E6/2^32*256*16=29 Hz
	bsr	envoie_donnees
	bsr	adread
	cmp.l	#0x22000000,er3		; STOP VALUE at 4 MHz (3.984)
	bne 	boucle
	bra	debut

DELAI:mov.w   #0x002f, r4 	; Set loop counter but 1f marche pas
WAI1:	mov.w   #0x4fff, r5 	; Set loop counter
WAI:	dec.w   #1, r5 ; Program
	bpl	WAI
	dec.w   #1, r4
	bpl     WAI1
	rts

envoie_donnees:			; INPUT: relative frequency in ER3 (32 bits value)
	mov.b	#0x20,r0l		; 32 bits to be sent (bit counter)
freqdds:btst	#0,r3l:8	; envoie de 32 bits=freq
	bne   bas
	bclr	#0,@0xfffc7:8	; DATA=bit 0 of PORT 4
	bra	suite
bas:	bset	#0,@0xfffc7:8
suite:bset	#1,@0xfffc7:8	; CK=bit 1 of PORT 4
	bclr	#1,@0xfffc7:8	; CK=bit 1 of PORT 4
	rotr	er3:32
	dec.b	r0l
	bne	freqdds

footer:mov.b	#0x08,r0l		; 32 bits to be sent
	mov	#0x0,r3l:8		; r3l=footer
footdds:btst    #0,r3l:8		; envoie de 32 bits=freq
	bne     basfoot
	bclr	#0,@0xfffc7:8		; DATA=bit 0 of PORT 4
	bra	suitefo
basfoot:bset	#0,@0xfffc7:8 
suitefo:bset	#1,@0xfffc7:8		; CK=bit 1 of PORT 4
	bclr	#1,@0xfffc7:8		; CK=bit 1 of PORT 4
	rotr	r3l:8
	dec.b	r0l
	bne	footdds
	
	bset	#2,@0xffc7:8		; set FQ_UD=ack
	bclr	#2,@0xffc7:8
	rts

adread: bset    #5,@0xfffe8:8   ; A/D start conversion
cv:     btst    #7,@0xfffe8:8   ; conversion finished ?
        beq     cv      	; branch while bit Z=0 ie adf=0
        mov.b   @0xfffe8:8,r0l  ; reads ADCSR (?! ... p. 533)
        bclr    #7,@0xfffe8:8 	; datum read: ADF=0
        mov.b   @0xfffe2:8,r1l  ; read ADDRB=datum hi (lo in fffe1) for A/D1
snd:    btst    #7,@0xfffbc:8	; NOW SEND TO RS232
        beq     snd
        mov.b   r1l,@0xfffbb:8
        bclr    #7,@0xfffbc:8
	rts

	.end


