; 01/08/2001, H8/3048 + DDS + 2x16 LCD
; 2min15sec pour un sweep de 6 a 4 MHz avec increments de 0xFF

; DDS connections: DATA=P4-0=1-31;     CK=P4-1=1-32;     FQ_UD=P4-2=1-33
	.h8300h
; .section .start
	.align 1
	.global _start

_start:
       mov.l   #0xffefc,er7		; =mov.l ...,sp : sett stack pointer
       ldc.b   #0xc0,  ccr             ; disable interrupt
       mov.b   #0x00,  r0l             ; 2-State Access(All area)
       mov.b   r0l,@0xffffed

       mov.b   #0xff,r0l  		; set P4 as output
       mov.b   r0l,@0xfffc5 		; |
       mov.b   r0l,@0xfffc8 		; set P5 as output
       MOV.B   r0l,@0xfffDa
       MOV.B   r0l,@0xfffC4
       MOV.B   r0l,@0xfffd8
       mov.b   #0x00,r0l  		; set P4 low
       mov.b   r0l,@0xfffc7 		; |

       bset    #0x0,@0xfffe8:8 ; select A/D 1 (fffe8=AD1 ctrl) 

       bset    #4,@0xfffba:8   ; SCI initialization
       bset    #5,@0xfffba:8   ; |     
       mov.w   #0xff00,r0      ; |
       mov.b   r0h,@0xfffd4:24 ; |

	JSR     DELAI           ;15ms
	jsr	init_lcd

init_dds:
	bset	#1,@0xfffc7:8		; CK=bit 1 of PORT 4
	bclr	#1,@0xfffc7:8		; CK=bit 1 of PORT 4
	jsr	DELAI
	bset	#2,@0xfffc7:8		; FQ_UD=bit 1 of PORT 4
	bclr	#2,@0xfffc7:8		; FQ_UD=bit 1 of PORT 4
	bsr	DELAI

debut:
	bset	#0,@0xfffca:8	; P5DR et C8 -> FF pour out:
	bclr	#1,@0xfffca:8	; P5DR et C8 -> FF pour out:
	bsr	DELAI
	bclr	#0,@0xfffca:8	; P5DR et C8 -> FF pour out:
	bset	#1,@0xfffca:8	; P5DR et C8 -> FF pour out:

	mov.l	#0x66000000,er3	; 80E6/2^32*256*256*256*(16*6+6)=31.2 M

	mov	#0x01,r1l	; suite de valeurs indiquant une nouvelle
	jsr	snd		; acquisition (nouveau sweep de freq)
	mov	#0xff,r1l	; RECHERCHER DANS LE FICHIER L_OCCURENCE DE
	jsr	snd		; LA SUITE : 01 FF 02 FE 80
	mov	#0x02,r1l	; POUR SAVOIR OU` COMMENCE UN BALAYAGE DE FREQ
	jsr	snd
	mov	#0xfe,r1l
	jsr	snd
	mov	#0x80,r1l
	jsr	snd

boucle:
	sub.l	#0x00002000,er3	; freq dec par 30E6/2^32*256*16=29 Hz
	bsr	envoie_donnees

; la condition d_affichage de la freq est er3==XXX00000
	mov	r3,r0:16	; octet de poids faible de e3 dans r0h
	bne	contin		; on n_affiche que de temps en temps
	mov	e3,r0:16
	and	#0xf,r0:8	; on en affiche encore un peu moins ...
	bne	contin		; on n_affiche que de temps en temps
	
	push	er3
	jsr	affich_fr	; affichage de la valeur courante en hexa
	jsr	my_affich_fr	; affichage de la frequence en Hz
	pop	er3

contin:	bsr	adread
	cmp.l	#0x44000000,er3	; STOP at 80E6/2^32*256*256*256*(16*4+4)=21.2 M
	bne 	boucle
	bra	debut

to_hz: 	; mov.w #0x8f,r0		; division par 1/(30E6/2^32)=143(.16)
 	mov.w #0x36,r0			; division par 1/(80E6/2^32)=53.7=54
	mov.w e3,r2			; quand on affiche le long resultant,
	extu.l        er2		; on a la frequence en Hz
	divxu.w       r0,er2
	mov.w e2,e3
	divxu.w       r0,er3
	mov.w r2,e3
	rts   

DELAI:	mov.w   #0x002f, r4 	; Set loop counter but 1f marche pas
WAI1:	mov.w   #0x4fff, r5 	; Set loop counter
WAI:	dec.w   #1, r5 ; Program
	bpl	WAI
	dec.w   #1, r4
	bpl     WAI1
	rts

envoie_donnees:			; INPUT: relative freq in ER3 (32 bits value)
	mov.b	#0x20,r0l	; 32 bits to be sent (bit counter)
freqdds:btst	#0,r3l:8	; envoie de 32 bits=freq
	bne   bas
	bclr	#0,@0xfffc7:8	; DATA=bit 0 of PORT 4
	bra	suite
bas:	bset	#0,@0xfffc7:8
suite:bset	#1,@0xfffc7:8	; CK=bit 1 of PORT 4
	bclr	#1,@0xfffc7:8	; CK=bit 1 of PORT 4
	rotr	er3:32
	dec.b	r0l
	bne	freqdds
footer:mov.b	#0x08,r0l		; 32 bits to be sent
	mov	#0x0,r3l:8		; r3l=footer
footdds:btst    #0,r3l:8		; envoie de 32 bits=freq
	bne     basfoot
	bclr	#0,@0xfffc7:8		; DATA=bit 0 of PORT 4
	bra	suitefo
basfoot:bset	#0,@0xfffc7:8 
suitefo:bset	#1,@0xfffc7:8		; CK=bit 1 of PORT 4
	bclr	#1,@0xfffc7:8		; CK=bit 1 of PORT 4
	rotr	r3l:8
	dec.b	r0l
	bne	footdds
	bset	#2,@0xffc7:8		; set FQ_UD=ack
	bclr	#2,@0xffc7:8
	rts

adread: bset    #5,@0xfffe8:8   ; A/D start conversion
cv:     btst    #7,@0xfffe8:8   ; conversion finished ?
        beq     cv      	; branch while bit Z=0 ie adf=0
        mov.b   @0xfffe8:8,r0l  ; reads ADCSR (?! ... p. 533)
        bclr    #7,@0xfffe8:8 	; datum read: ADF=0
        mov.b   @0xfffe2:8,r1l  ; read ADDRB=datum hi (lo in fffe1) for A/D1
snd:    btst    #7,@0xfffbc:8	; NOW SEND TO RS232
        beq     snd
        mov.b   r1l,@0xfffbb:8
        bclr    #7,@0xfffbc:8
	rts

init_lcd:MOV.B	#0b00100011,r0l	; 4 bit mode
	JSR	@dlcd_4
	MOV.B	#0b00100011,r0l	;  4 bit mode
	JSR	@dlcd_4
	MOV.B	#0b00100011,r0l	;  4 bit mode
	JSR	@dlcd_4
	MOV.B	#0b00100010,r0l	; set 4 bit operations 
	JSR	@dlcd_4

	MOV.B	#0b00101000,r0l	; 11.1/2: 00101000 in 8 bit mode
	jsr	sndcmd8		;           4 bits, 2 lines, 5x8 dots font
	MOV.B	#0b00001000,r0l	; 13.1/2: 00001000 in 8 bit mode
	jsr	sndcmd8                     disp. off, curs. off, blink off
	MOV.B	#0b00001110,r0l	; 15.1/2: 00001111 in 8 bit mode
	jsr	sndcmd8                     disp. on, curs. on, blink off
	MOV.B	#0b00000110,r0l	; 17.2	; 00000110 in 8 bit mode
	jsr	sndcmd8                     inc. curs. pos., no disp. shift
	rts

snddat8:		; send 8 bits data (!= cmds)
	mov.b	r0l,r1l:8
        SHLR.B  r1l:8
        SHLR.B  r1l:8
        SHLR.B  r1l:8
        SHLR.B  r1l:8
	AND.B   #0x0F,r1l:8
				
	MOV.B	r1l,@0xfffC6:8
	BSET	#4,@0xfffC6:8	; RS=0 -> 1 (datum)
	BSET	#5,@0xfffC6:8	; E -> 1
	JSR	@time00	
	BCLR	#5,@0xfffC6:8
	JSR	@time00	

	mov.b	r0l,r1l:8
	AND.B	#0x0F,r1l:8
	MOV.B	r1l,@0xfffC6:8
	BSET	#4,@0xfffC6:8	; RS=0 -> 1 (datum)
	BSET	#5,@0xfffC6:8	; E -> 1
	JSR	@time00
	BCLR	#5,@0xfffC6:8	
	JSR	@time00
	RTS

sndcmd8:		; send 8 bits cmd
	mov.b	r0l,r1l:8
        SHLR.B  r1l:8
        SHLR.B  r1l:8
        SHLR.B  r1l:8
        SHLR.B  r1l:8
	AND.B   #0x0F,r1l:8
				
	MOV.B	r1l,@0xfffC6:8
	BCLR	#4,@0xfffC6:8	; RS-> 0 (cmd)
	BSET	#5,@0xfffC6:8	; E -> 1
	JSR	@time00	
	BCLR	#5,@0xfffC6:8
	JSR	@time00	

	mov.b	r0l,r1l:8
	AND.B	#0x0F,r1l:8
	MOV.B	r1l,@0xfffC6:8
	BCLR	#4,@0xfffC6:8	; RS=0 (cmd)
	BSET	#5,@0xfffC6:8	; E -> 1
	JSR	@time00
	BCLR	#5,@0xfffC6:8	
	JSR	@time00
	RTS

time00: PUSH.w  r0		; SHORT delay (avoids waisting too much time
        mov.w   #0x001f,r0	; on display), must be > 0x000f
time01: SUB.w   #1,r0
        BNE     time01
        POP.w   r0
        RTS

dlcd_4:	MOV.B	r0l,@0xfffC6:8
	JSR	@time00		
	BCLR	#5,@0xfffC6:8	; RS -> 0
	BSET    #4,@0xfffC6:8	; E=hi
 	JSR	@time00
	RTS

prn_msg:mov.b   @er3+,r0l
        jsr     @snddat8	; (r2l contient le nbre de chars a afficher,
        dec.b   r2l		; er3 pointe sur la chaine de chars a printer)
        bne     prn_msg
	rts

my_affich_fr:			; FREQ TO BE DISPLAYED IS XFERED IN ER3
        MOV.B 	#0b11000000,r0l ; AFFICHAGE DE LA FREQ en decimal
	jsr     sndcmd8         ; gotoxy (2nd line): pos 07

	jsr	to_hz		; convert to Hz (remove to simply display
				; a _long_ in decimal format)
	push	er3
        MOV.B   #0x05,r2l       ; display string top-left
        mov.l   #M2,er3
	jsr	prn_msg
	pop	er3
			; CONVERSION HEX -> DEC (pour 0 < N < 1E8)
	mov.l	#0x989680,er4	; =1E7
deb:	mov.b	#0x00,r2l
suit:	cmp.l	er4,er3		; test er3-er4
	blt	fini		; if er3<er4, then branch
	sub.l	er4,er3		; er4=er4-er3
	inc.b	r2l
	bra	suit
fini:	mov	r2l,r0l
	jsr	toprint

	cmp.l	#0xf4240,er4	; =1E6
	ble	fini1
	mov	#0xf4240,er4
	bra	deb
fini1:	cmp.l	#0x186a0,er4	; =1E5
	ble	fini2
	mov	#0x186a0,er4
	bra	deb
fini2:cmp.l	#0x2710,er4	; =1E4
	ble	fini3
	mov	#0x2710,er4
	bra	deb
fini3:cmp.l	#0x3e8,er4	; =1E3
	ble	fini4
	mov	#0x3e8,er4
	bra	deb
fini4:cmp.l	#0x64,er4	; =1E2
	ble	fini5
	mov	#0x64,er4
	bra	deb
fini5:cmp.l	#0xa,er4	; =10
	ble	fini6
	mov	#0xa,er4
	jmp	deb
fini6:	mov	r3l,r0l
	jsr	toprint		; ... et on affiche les unites 

        MOV.B   #03,r2l         ; _Hz_ en fin de ligne
        mov.l   #M3,er3
	jsr	prn_msg
	rts

toprint:and     #0x0f,r0l	; only display lowest nibble (r0l in 0..9)
        cmp     #0x0a,r0l       ; hexa -> ASCII
        blt     base2
        add     #0x07,r0l
base2:  add     #0x30,r0l
        jsr     @snddat8	
	rts

affich_fr:			; FREQ TO BE DISPLAYED IS XFERED IN ER3
        MOV.B 	#0b10000000,r0l ; AFFICHAGE DE LA FREQ en hexa
	jsr     sndcmd8         ; gotoxy (2nd line): pos 07

	push	er3
        MOV.B   #0x05,r2l       ; display string top-left
        mov.l   #M1,er3
	jsr	prn_msg
	pop	er3

	MOV.B   #0x08,r2l
snd_fr:	rotl	er3:32
	rotl	er3:32
	rotl	er3:32
	rotl	er3:32
	mov	r3l,r0l
	and	#0x0f,r0l
	cmp	#0x0a,r0l	; hexa -> ASCII
	blt	bbase
	add	#0x07,r0l
bbase:	add	#0x30,r0l
	jsr	@snddat8
	DEC.B   r2l
	BNE     snd_fr		; FIN AFFICHAGE FREQ SUR LCD
	rts

	.align 1
M1:	.string "hex: "
M2:	.string "frq: "
M3:	.string " Hz"
	.end	 
