/*
	h8term.c
	ˡ ߥʥץ
              by H.Namikata 1998/09/08
*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <termios.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/time.h>
#include <unistd.h>

#define DEVICE "/dev/cuaa0"

/* RAW ⡼ɥѿ */
struct termios _tbufsave;
char _keybuf[10];

/* RAW ⡼ɤѹ                     */
/* Ϥ wait̵̵ˤ  */
/* ɬǸ restoreinkey()Ƥ֤  */
void setraw(void)
{
	struct termios tbuf;

#if 0
	if(ioctl(0,TIOCGETA,&tbuf) == -1) {
		fprintf(stderr,"ioctl:TIOCGETA error\n");
		exit(1);
	}
#else

	if(tcgetattr(0,&tbuf) < 0 ) {
		fprintf(stderr,"Not get key\n");
		exit(1);
	}
#endif
	_tbufsave = tbuf;
	tbuf.c_iflag &= ~(IGNBRK|BRKINT|PARMRK|ISTRIP|INLCR|IGNCR|ICRNL|IXON);
	/* tbuf.c_oflag &= ~OPOST; */
	tbuf.c_lflag &= ~(ECHO|ECHONL|ICANON|ISIG|IEXTEN);
	tbuf.c_cc[4] = sizeof(_keybuf);
	tbuf.c_cc[5] = 2;
#if 0
	if(ioctl(0,TIOCSETA,&tbuf) == -1) {
		fprintf(stderr,"ioctl:TIOCSETA error\n");
		exit(1);
	}
#else
	if(tcsetattr(0,TCSANOW,&tbuf) < 0 ) {
                fprintf(stderr,"Not set key\n");
                exit(1);
        }

#endif
}


/* ϥ롼                             */
/* 줿֤ Ԥ̵ ̵   */
/* CTRLϲǽ(CTRL-CǤ⥹ȥåפʤ) */
/* ɬǸ restoreinkey()Ƥ֤          */
char inkey(void)
{
	static int total=0,next=0;
	static int first = 1;
	struct termios tbuf;

	if(first) {
		first = 0;
		setraw();
	}
	if(next >= total) {
		switch(total = read(0,_keybuf,sizeof(_keybuf))) {
		case -1:
			perror("read");
		case 0:
			fprintf(stderr,"Mysterious EOF");
			exit(1);
		default:
			next = 0;
		}
	}
	return _keybuf[next++];
}

/* RAW⡼ɤ */
void restoreinkey(void)
{
#if 0
	if(ioctl(0,TIOCSETA,&_tbufsave) == -1) {
		fprintf(stderr,"ioctl:TIOCSETA error\n");
		exit(1);
	}
#else
	tcsetattr(0,TCSANOW,&_tbufsave);
#endif
}

/* RS232C ѿ                              */
struct termios _rstbufsave;
/* RS232C com1 port 롼            */
/* 19200bps 8bit ѥƥ̵ ȥåץӥå1 */
/* XON,XOFF                               */
/* եϥɥ֤                     */
int rs232c_open(char *device_rs)
{
  int fd,pgrp;
  struct termios tbuf;

#if 0
  fd = open(device_rs,O_RDWR|O_NDELAY);
#else
  fd = open( device_rs , O_RDWR | O_NOCTTY);
#endif
  if(fd == -1) {
    fprintf(stderr,"Cannot open %s\n",device_rs);
    exit(1);
  }

  /*---  cuaa0Ϥ  ---*/
#if 0
  if (ioctl(fd, TIOCGETA, &tbuf) == -1){
    fprintf(stderr,"ioctl read errno:%d %s\n",errno,
      (errno > 0 && errno < sys_nerr ? sys_errlist[errno] : ""));
    exit(1);
  }
#else
    pgrp=tcgetpgrp(fd);
    if(pgrp>=0){
        fprintf(stderr,"Another program uses serial device.\n");
        exit(1);
    }
    tcsetpgrp(fd,getpgrp());
    tcgetattr(fd,&tbuf);
#endif
  _rstbufsave = tbuf;

#if 0
  tbuf.c_ispeed = B19200;                           /*  19200bps  */
  tbuf.c_ospeed = B19200;                           /*  19200bps  */
#else
    cfsetispeed(&tbuf,B19200);
    cfsetospeed(&tbuf,B19200);
#endif
  tbuf.c_cflag = (tbuf.c_cflag & (~CSIZE)) |CS8;   /* data 8bit     */
  tbuf.c_cflag &= ~CSTOPB;                         /* stop bit 1    */
  tbuf.c_cflag &= ~PARENB;                         /* parity none   */
  tbuf.c_cflag |= CREAD;                           /* enable recive */
  tbuf.c_cflag |= HUPCL;                           /*     */
  tbuf.c_cflag |= CLOCAL;                          /*   */
  tbuf.c_oflag &= ~OPOST;                         /*  ʸ ̵  */
  tbuf.c_iflag |= IXON;                           /* XON եȥ */
  tbuf.c_iflag |= IXOFF;                          /* XOFFեȥ */
/* set raw mode */
  tbuf.c_iflag &= ~(IGNBRK|BRKINT|PARMRK|ISTRIP|INLCR|IGNCR|ICRNL);
  tbuf.c_lflag &= ~(ECHO|ECHONL|ICANON|ISIG|IEXTEN);

#if 0
  if(ioctl(fd, TIOCSETA,&tbuf) == -1){ 
      fprintf(stderr,"ioctl set errno:%d %s\n",
        errno, (errno > 0 && errno < sys_nerr ? sys_errlist[errno] : ""));
      exit(1); 
  } 
#else
  tcflush(fd, TCIFLUSH);
  tcsetattr(fd,TCSANOW,&tbuf);
#endif
  return fd; 
}

/* RS232CΥ */
void rs232c_close(int fd)
{

#if 0
  if (ioctl(fd, TIOCSETA, &_rstbufsave) == -1){
    fprintf(stderr, "errno:%d %s\n", errno,
	    (errno > 0 && errno < sys_nerr ? sys_errlist[errno] : ""));
    exit(1);
  }
#else
  tcsetattr(fd,TCSANOW,&_rstbufsave);
#endif
  close(fd);
}

/* ǡ򥢥åץɤ */
void up_load_file(int fd_rs)
{
  char buf[1024];
  FILE *fp;
  fd_set readfds,writefds;
  char c;


  printf("\n    Upload file name : ");

  restoreinkey();           /* ϥ⡼ɤ򸵤᤹ */
  fgets(buf,sizeof(buf),stdin);
  setraw();                 /* Ϥraw⡼ɤ */
  
  buf[strlen(buf)-1] = '\0';
  if(strlen(buf)<1) {
    printf("     ->cansel upload\n");
    return;
  }

  if((fp=fopen(buf,"rb"))==NULL) {
    printf("     ->File %s not exist.\n",buf);
    return;
  }
  while((c=fgetc(fp))!=EOF) {
    if(c==0x0d) continue;

    FD_ZERO(  &readfds);  /* selectˤꥭܡɤRS232CϤԤ */
    FD_SET( 0,&readfds);
    FD_SET(fd_rs,&readfds);
    FD_ZERO(&writefds);       /* RS232Cν񤭹OKԤ */
    FD_SET(fd_rs,&writefds);
    select(fd_rs+1,&readfds,&writefds,(fd_set *)0,NULL);
 /*   select(fd_rs+1,&readfds,(fd_set *)0,(fd_set *)0,NULL); */

    if(FD_ISSET(fd_rs,&readfds)) {   /* RS232CϤä */
      fclose(fp);
      printf("\n");
      return;
    }
    if(FD_ISSET(0,&readfds)) {
      printf("\n     ->User break upload.\n");
      fclose(fp);
      c = '\n';
	if(write(fd_rs,&c,sizeof(c))==-1) {
	  fprintf(stderr, "write(fd_rs) errno:%d %s\n", errno,
		  (errno > 0 && errno < sys_nerr ?
		   sys_errlist[errno] : ""));
	  return;
	}
      
      return;
    }
    if(FD_ISSET(fd_rs,&writefds)) {
      if(write(fd_rs,&c,sizeof(c))==-1) {
	fprintf(stderr, "write(fd_rs) errno:%d %s\n", errno,
		(errno > 0 && errno < sys_nerr ?
		 sys_errlist[errno] : ""));
	return;
      }
    }

  }
}

/* ESCϥ롼 */
void key_esc(int fd)
{
  int c;

  printf("\n------------------ menu --------------------\n");
  printf("    upload data       :1\n");
  printf("    exit this program :2\n");
  printf("    exit this menu    :esc\n");
  while(1) {
    c = inkey();
    if(c=='1') {
      up_load_file(fd);
      break;
    }
    if(c=='2') {
      printf("--------------------------------------------\n");
      printf("\n\n");
      rs232c_close(fd);
      exit(0);
    }
    if(c==0x1b) {
      break;
    }

  }
  printf("--------------------------------------------\n");
}

/* ˡɽ */
void print_usage(char *argv[])
{
  printf("tiny terminal program\n");
  printf("   usage: %s [-d device]\n",argv[0]);
  printf("   [ESC] key to menu\n");
}

/* ץβ */
void get_device(int argc,char *argv[],char *device_rs)
{
  int i;

  if(argc==1) {
    strcpy(device_rs,DEVICE);
    return;
  }
  
  for(i=1;i<argc;i++) {
    if( *argv[i] == '-') {
      switch(*(argv[i]+1)) {
      case 'd' :
      case 'D' :
	if(strlen(argv[i]) > 2) {
	  strcpy(device_rs,(argv[i]+2));
	} else {
	  strcpy(device_rs,argv[i+1]);
	  i++;
	}
	break;
      case 'h' :
	print_usage(argv);
	exit(0);
      default:
	print_usage(argv);
	exit(1);
      }
    } else {
      print_usage(argv);
      exit(1);
    }
  }
}
  

main(int argc, char *argv[])
{
  int fd;
  char c;
  char buf[16];
  fd_set readfds;
  struct timeval timeout;
  char device_rs[256];

  get_device(argc,argv,device_rs);

  printf("\n\n");
  printf("************************\n");
  printf("* H8 tiny Terminal     *\n");
  printf("*    [ESC] key to menu *\n");
  printf("************************\n\n");

  fd = rs232c_open(device_rs);

  atexit(restoreinkey); /* ץνλ˥Ϥ򸵤᤹ */
	
  for(;;){
    timeout.tv_sec = 100;    /* selectˤꥭܡɤRS232CϤԤ */
    timeout.tv_usec = 0;
    FD_ZERO(  &readfds);
    FD_SET( 0,&readfds);
    FD_SET(fd,&readfds);
    select(fd+1,&readfds,(fd_set *)0,(fd_set *)0,&timeout);

    if(FD_ISSET(fd,&readfds)) {   /* RS232CϤä */
      if (read(fd, &c, sizeof(c)) == -1){
	fprintf(stderr, "read(fd) errno:%d %s\n", errno,
		(errno > 0 && errno < sys_nerr ? sys_errlist[errno] : ""));
	exit(1);
      }
      printf("%c",c);
      fflush(stdout);
    }
    if(FD_ISSET(0,&readfds)) {    /* Ϥä */
      c = inkey();
      if(c == 0x1b) key_esc(fd);
      if(write(fd,&c,sizeof(c))==-1) {
	fprintf(stderr, "write(fd) errno:%d %s\n", errno,
	        (errno > 0 && errno < sys_nerr ?
	         sys_errlist[errno] : ""));
	exit(1);
      }
    }
			
  }
     
     
     /*--- ᤹ ---*/
  printf("\n\n");
  rs232c_close(fd);       
}

