#include "rs232.h"
#include <fcntl.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>


void send_h8(FILE *f,int fd)
{unsigned char buf;char prg[3072];int i=0,status;unsigned int j;
 do {status=fscanf(f,"%c",&buf);prg[i]=(char)buf;i++;} /* read while !EOF */
    while ((status!=EOF) && (i<3072));
  if (i<3072) i--;printf("%d bytes read from file\n",i);
  buf=(char)(i/256);write(fd,&buf,1);read(fd,&buf,1);
      printf("%d -> %d \n",i/256,(int)buf&0x000000FF);
  buf=(char)(i%256);write(fd,&buf,1);read(fd,&buf,1);
      printf("%d -> %d \n",i%256,(int)buf&0x000000FF);
  for (j=0;j<i;j++) {write(fd,&prg[j],1);read(fd,&buf,1);
      printf("%d -> %d \n",(int)prg[j]&0x000000FF,(int)buf&0x000000FF);}
}
 
void init_comm(int fd)
{char buf;int i;
 fd_set rfds;
 struct timeval tv;
 int retval=0;

  while (!retval) {
    FD_ZERO(&rfds);FD_SET(fd, &rfds);                  /* Watch stdin (fd 0) */
    tv.tv_sec = 1;tv.tv_usec = 00;                  /* Wait up to X seconds. */
    retval = select(fd+1, &rfds, NULL, NULL, &tv);
    retval=FD_ISSET(fd,&rfds);
    if (retval) printf("Data is available now.\n");
        else {printf(".");fflush(stdout);buf=0;
   	      for (i=0;i<255;i++) write(fd,&buf,1);}
    }
  read(fd,&buf,1);
  printf("received: 0x%x\n",(int)buf&0x000000FF); // read data received from H8
  buf=0x55;write(fd,&buf,1);                      // send acknowledgement
  read(fd,&buf,1);
  printf("received: 0x%x\n",(int)buf&0x000000FF); // read data received from H8
  printf("init finished \n");
}

int main(int argc,char **argv)
{int fd;FILE *f;
 if (argc<2) printf("%s filename\n",argv[0]); else {
    fd=init_rs232();init_comm(fd);
    f=fopen(argv[1],"r");send_h8(f,fd);fclose(f);
 /* free_rs232(); */
    } return(0);
}

