        .h8300h
; .section .start
        .align 1
        .global _start

_start:
       mov.l   #0xffefc,er7             ; =mov.l ...,sp : sett stack pointer
       ldc.b   #0xc0,  ccr             ; disable interrupt
       mov.b   #0x00,  r0l             ; 2-State Access(All area)
       mov.b   r0l,     @0xffffed

       mov.b   #0xff,r0l                
       mov.b   r0l,@0xfffc0             ; set P1=@0..7 as output
       mov.b   r0l,@0xfffc1             ; set P2=@8..15 as output
       mov.b   r0l,@0xfffc8             ; set P5=@16.. as output
       mov.b   r0l,@0xfffec             ; set RAM to 8 bits wide access
       mov.b   #0xe8,r0l                
       mov.b   r0l,@0xfffcd             ; set RAM to CS1#
       mov.b   #0x00,r0l                
       mov.b   r0l,@0xfffed             ; all areas = 2 wait state
       mov.b   #0xf0,r0l                
       mov.b   r0l,@0xfffee             ; WSC is programmable ???????
       mov.b   #0xff,r0l                
       mov.b   r0l,@0xfffef             ; all areas use WSC   ???????

        bset    #4,@0xfffba:8   ; SCI initialization
        bset    #5,@0xfffba:8   ; |     
        mov.w   #0xff00,r0      ; |
        mov.b   r0h,@0xfffd4:24 ; |

        bsr     rcv
        mov.l   #0x20000,er3    ; start of RAM
fill:   mov.b   @er3,r2l        ; read current RAM value
        bsr     snd             ; send it
        bsr     rcv             ; read new value
        mov.b   r2l,@er3        ; store it
	mov.b   @er3,r2l        ; read current RAM value
        bsr     snd             ; send it

        add.l   #1,er3          ; next RAM cell ... 
        jmp     fill

rcv:    btst    #6,@0xfffbc:8
        beq     rcv
        mov.b   @0xfffbd:8,r2l
        bclr    #6,@0xfffbc:8
        rts

snd:    btst    #7,@0xfffbc:8
        beq     snd
        mov.b   r2l,@0xfffbb:8
        bclr    #7,@0xfffbc:8
        rts

        .end
