OUTPUT_ARCH(h8300h)

MEMORY
{
  rom : o = 0x000000, l = 64k
  ram : o = 0x040000, l = 64k
}

SECTIONS 
{
  .vectors 0x000000 :
    {
    *(.vect);
    } > rom

  .text 0x000100 :
    {
    *(.text)
    *(.rodata)
     _etext = ALIGN(16);
     } > rom

  .data : AT(_etext) /* places a ROM image at _etext */
    {
    _data = .;
    *(.data)
    _edata = .; 
    } > ram

  .bss (NOLOAD) :
    {
    _bss = .; 
    *(.bss)
    *(COMMON)
    _ebss = .;
    _end = .;  
    } > ram

  .stack 0x04FC00 (NOLOAD) : /* allow room for 512 words of gdbstub stack */
    {
    _stack = .; 
    *(.stack)
    } > ram

  .stab 0 (NOLOAD) :
    {
    *(.stab)
    }

  .stabstr 0 (NOLOAD) :
    {
    *(.stabstr)
    }
}
