/*
* hwinit.c
*
* Hardware initialization routine called by the startup code before the
* sections are initialised.  Bus controller, and other essential hardware
* setup code should be placed here.
*
* H8/300H hardware initialisation, called immediately after startup
* by crt0.s, before any variable initialization or entry into main().
*
* for system init, refer to init() in init.c
*
*/

#include "h3003.h"
#include "hwinit.h"

/*
* hw_initialize
* initialize hardware
*
* input:
* <none>
*
* output:
* <none>
*
* process:
*
*/
void hw_initialize(void)
{
  ABWCR = 0xFB;     /* area 0 = 8 bit, area 2 = 16 bit */
  ASTCR = 0x01;     /* 2-state RAM, 3-state ROM (req'd for AICOM) */
  WCR   = 0xF3;     /* (default) */
  WCER  = 0xFF;     /* (default */
  SYSCR = 0x0B;     /* (default) */

  P8DDR = 0xF4;     /* enable CS0/ and CS2/ outputs */

  PCDR  &= ~0x01;   /* turn off the LED */
  PCDDR |= 0x01;    /* set bit 0 for output */
}
